package cn.net.caoyao.cpzshandset.service.thread.impl.yth;

import java.io.IOException;
import java.net.SocketTimeoutException;
import java.util.List;

import android.os.Handler;
import android.os.Message;

import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.service.bll.ConsigneeBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.ConsigneeBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20013ResBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20013ReqConsignee;

public class YthReqConsigeeRunable implements Runnable {
	private Handler mHandler;
	private long deveicedId; 
	private ConsigneeBll consigeeBll;
	public YthReqConsigeeRunable(Handler mHandler, long deveicedId,ConsigneeBll consigeeBll) {
		this.mHandler = mHandler;
		this.deveicedId = deveicedId;
		this.consigeeBll = consigeeBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, String.valueOf(deveicedId));
		try {
			create.createLoginCpzsHandset(deveicedId);
			if (create.isResult()) {
				Prot20013ReqConsignee stationReq = new Prot20013ReqConsignee();
				stationReq.dealConsigneeList(create);
				Prot20013ResBean resBean = stationReq.getConsignees();
				if (resBean.getResult() == 0) {
					//0：请求成功     1：遇到错误信息，返回错误码
					if (resBean.getCustomer() != null && resBean.getCustomer().size()>0) {
						insertConsigeeInfo(resBean.getCustomer());
					}else {
						mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_CONSIGEE_20013_NO_DATA);
					}
				} else {
					Message failMsg = mHandler.obtainMessage();
					failMsg.what = RequestConstant.PROT_REQ_CONSIGEE_20013_FAIL;
					failMsg.obj = resBean;
					mHandler.sendMessage(failMsg);
				}
				
			} else {
//				mHandler.sendEmptyMessage(ThreadConstant.)
				Message loginFailMsg = mHandler.obtainMessage();
				loginFailMsg.obj = create.getErrMsg();
				loginFailMsg.arg1 = create.getiErrCode();
				loginFailMsg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				mHandler.sendMessage(loginFailMsg);
			}
		}catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally{
			new Prot02Logout().dealLogout(create);
		}
	}

	private void insertConsigeeInfo(List<ConsigneeBean> cBeans) {
		consigeeBll.deleteAllConsigee();
		consigeeBll.insertAllConsignee(cBeans);
		mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_CONSIGEE_20013_SUCCESS);
	}

}
